/**
 * A brief explanation for "project.json":
 * Here is the content of project.json file, this is the global configuration for your game, you can modify it to customize some behavior.
 * The detail of each field is under it.
 {
 "project_type": "javascript",
 // "project_type" indicate the program language of your project, you can ignore this field

 "debugMode"     : 1,
 // "debugMode" possible values :
 //      0 - No message will be printed.
 //      1 - cc.error, cc.assert, cc.warn, cc.log will print in console.
 //      2 - cc.error, cc.assert, cc.warn will print in console.
 //      3 - cc.error, cc.assert will print in console.
 //      4 - cc.error, cc.assert, cc.warn, cc.log will print on canvas, available only on web.
 //      5 - cc.error, cc.assert, cc.warn will print on canvas, available only on web.
 //      6 - cc.error, cc.assert will print on canvas, available only on web.

 "showFPS"       : true,
 // Left bottom corner fps information will show when "showFPS" equals true, otherwise it will be hide.

 "frameRate"     : 60,
 // "frameRate" set the wanted frame rate for your game, but the real fps depends on your game implementation and the running environment.

 "id"            : "gameCanvas",
 // "gameCanvas" sets the id of your canvas element on the web page, it's useful only on web.

 "renderMode"    : 0,
 // "renderMode" sets the renderer type, only useful on web :
 //      0 - Automatically chosen by engine
 //      1 - Forced to use canvas renderer
 //      2 - Forced to use WebGL renderer, but this will be ignored on mobile browsers

 "engineDir"     : "frameworks/cocos2d-html5/",
 // In debug mode, if you use the whole engine to develop your game, you should specify its relative path with "engineDir",
 // but if you are using a single engine file, you can ignore it.

 "modules"       : ["cocos2d"],
 // "modules" defines which modules you will need in your game, it's useful only on web,
 // using this can greatly reduce your game's resource size, and the cocos console tool can package your game with only the modules you set.
 // For details about modules definitions, you can refer to "../../frameworks/cocos2d-html5/modulesConfig.json".

 "jsList"        : [
 ]
 // "jsList" sets the list of js files in your game.
 }
 *
 */

//--------------------------------------------------< ここから

//var _DEBUG_ = true;   // 開発用
var _DEBUG_ = false;    // 本番
var packageName = "jp/vgame/sarval/AppActivity";

var tweet_ios = "";
var tweet_android = "";
//--------------------------------------------------< ここまで
if(cc.sys){
    var scene3SearchPaths = cc.sys.localStorage.getItem("Scene3SearchPaths");
    if (scene3SearchPaths)
        jsb.fileUtils.setSearchPaths(JSON.parse(scene3SearchPaths));
}
cc.game.onStart = function(){
    cc.view.adjustViewPort(true);
    cc.view.resizeWithBrowserSize(true);
    var screenSize = cc.view.getFrameSize();
    // if ((screenSize.width == 960 && screenSize.height == 640) ||
    //     (screenSize.width == 480 && screenSize.height == 320))
    // {
    //     cc.view.setDesignResolutionSize(960, 640, cc.ResolutionPolicy.SHOW_ALL);
    //     is4s = 1;
    //     cc.log("============< 4S サイズ>================")
    // }
    // else
    // {
    //     cc.view.setDesignResolutionSize(1136, 640, cc.ResolutionPolicy.SHOW_ALL);
    //     cc.log("============<  ノーマル　サイズ>================")
    // }
    cc.view.setDesignResolutionSize(320, 568, cc.ResolutionPolicy.SHOW_ALL);
    cc.director.setProjection(cc.Director.PROJECTION_2D);

    gWinSize = cc.director.getWinSize();

    if(cc.sys.os == cc.sys.OS_ANDROID) {
        isAndroid = 1;
    }

    // Set resources path
    cc.loader.resPath = "./res";
    // Set audio files path
    cc.loader.audioPath = "./res/sound";
    // Set CCB file path
    cc.BuilderReader.setResourcePath("res/");

    var searchPaths = jsb.fileUtils.getSearchPaths();
    searchPaths.push('script');
    searchPaths.push('src');
    var paths = [
        'res',
        'res/images',
        'res/images/common',
        'res/images/char',
        'res/cocosui',
        'res/ccb',
        'res/effect',
        'res/font',
        'res/sound',
        'res/sound/se',
        'res/map'
    ];
    for (var i = 0; i < paths.length; i++) {
        searchPaths.push(paths[i]);
    }
    jsb.fileUtils.setSearchPaths(searchPaths);


    Utils.dataLoad();
    gSoundManager = new SoundManager(gVolBgm, gVolSe);

    if (is4s == 0)
    {
        var scene = cc.BuilderReader.loadAsScene(res.ccb_Title);
        cc.director.runScene(scene);
    }
    else
    {
        var scene = cc.BuilderReader.loadAsScene(res.ccb_Title4s);
        cc.director.runScene(scene);
    }
};
cc.game.run();
