//*****************************************************************************
//  ゲームメイン
///*****************************************************************************
cc.BuilderReader.registerController("Scene_GameMain", {

_frameCounter: 0,
_mapManager: null,
_fadeNode : null,
_sttmsgNode : null,

onDidLoadFromCCB : function ()
{
    Utils.setSceneNum(SCENE.MAIN);

 //   Utils.showBannerView();

    g_sharedGameScene = this;

    var aboutNode = cc.BuilderReader.load(res.ccb_Fade);
    aboutNode.controller.setDelegate(this);
    this._ccb_dialogLayer.addChild(aboutNode, Z_ORDER.FADE, LAYER_TAG.FADE);
    aboutNode.controller.init("fadeout");
    this._fadeNode = aboutNode;
                                    
                                    this._spr_tap.setVisible(false);

    this.rootNode.onEnterTransitionDidFinish = function()
    {
        this.controller.initGame();
        this.schedule(this.controller.update);
    };

    this.rootNode.onExitTransitionDidStart = function()
    {
        gSoundManager.clearSEpoolTimer();
        gSoundManager.setSePoolEnable(false);
    };

    this.rootNode.onExit = function()
    {
        this.unschedule(this.controller.update);
        this.controller.onExit();
    };

    // タッチ用リスナー
    this._touchListener = cc.EventListener.create({
             event: cc.EventListener.TOUCH_ONE_BY_ONE,
                                swallowTouches: true,
                                onTouchBegan: this.onTouchBegan,
                                onTouchMoved: this.onTouchMoved,
                                onTouchEnded: this.onTouchEnded
        });
    cc.eventManager.addListener(this._touchListener, this.rootNode);
},
onExit : function()
{
    cc.eventManager.removeListener(this._touchListener);
    this.exitGame();
    g_sharedGameScene = null;
},
onTouchBegan : function(touch, event)
{
    if (!gTouchEnable || gPauseNow) return false;

    var target = event.getCurrentTarget();
    var self = target.controller;
    var pos = target.convertToNodeSpace(touch.getLocation());
    var size = self._touchArea;

    if (gGameStat == GAME_STATE.GS_MAIN && !gWinFlag && !gLoseFlag)
    {
      //  if (cc.rectContainsPoint(self._touchAreaRect, pos))
      //  {
            gJumpFlag = true;

//            var tex = cc.textureCache.addImage("btn_tap_on.png");
//            self._spr_tap.setTexture(tex);
//            var rect = tex.getContentSize();
//            self._spr_tap.setTextureRect(cc.rect(0,0,rect.width,rect.height));

            if (gStageType == 2) gSoundManager.playSE(SE.FLY);

            return true;
       // }
    }
    return false;
},
onTouchMoved : function(touch, event)
{
    var target = event.getCurrentTarget();
    var self = target.controller;
    var pos = target.convertToNodeSpace(touch.getLocation());
    var size = self._touchArea;

    if (gGameStat == GAME_STATE.GS_MAIN)
    {
               // ボタンタッチやめる
//        if (!cc.rectContainsPoint(self._touchAreaRect, pos))
//        {
//            self.touchCancel();
//        }
    }
},
onTouchEnded : function(touch, event)
{
    var target = event.getCurrentTarget();
    var self = target.controller;
    var pos = target.convertToNodeSpace(touch.getLocation());

    self.touchCancel();
},
touchCancel: function()
{
    var self = this;
//    var tex = cc.textureCache.addImage("btn_tap_off.png");
//    self._spr_tap.setTexture(tex);
//    var rect = tex.getContentSize();
//    self._spr_tap.setTextureRect(cc.rect(0,0,rect.width,rect.height));
    gJumpFlag = false;
},
//=============================================================================
// 初期化
//=============================================================================
initGame : function()
{
    var self = this;

    self._pressedButton = false;

    gGameStat = GAME_STATE.GS_INIT;
    gSubStat = 0;

    gPauseEnable = false;
    gPauseNow = false;
    gTouchEnable = false;

    gWinFlag = false;
    gLoseFlag = false;
    gClearDemo = false;
    gExtraLifeFlag = false;
    gContinueFlag = 0;

    gPlayer = null;
    gEnemies.length = 0;
    gBaneObj.length = 0;
    gWarpPoint.length = 0;

    gMapLength.length = 0;
    gMapLengthTotal = 0;
    gPlayerMapPos = 0;

    gAchievement = 0;

    gHeartGet = false;

    //this._label_stgNum.setString("STAGE "+ gStageNum);

    // ステージ作成
    self.createStageBG();

    // タッチできるエリア設定
    var size = self._spr_tap.getContentSize();
        self._touchAreaRect = cc.rect(self._spr_tap.x - size.width/2, self._spr_tap.y - size.height/2, size.width, size.height);
                                    
                                 //   self._spr_tap.hidden = true;

    self.updateUI();
},
exitGame : function()
{
    Spr_Enemy.allDestroy();
    Spr_Bane.allDestroy();
    gEnemies.length = 0;
    gBaneObj.length = 0;
    gWarpPoint.length = 0;
    gCheckPointList.length = 0;
    gMapLength.length = 0;
    gMapLengthTotal = 0;
    gPlayer = null;
    if (this._mapManager != null)
    {
        this._ccb_bgLayer.removeChild(this._mapManager);
    }
    this._mapManager = null;
},
//=============================================================================
// メイン処理
//=============================================================================
update : function(dt)
{
    gSoundManager.countDownSEpoolTimer();

    var self = this.controller;

    switch(gGameStat)
    {
    case GAME_STATE.GS_INIT:
                                    
                
        if (gSubStat == 0)
        {
            if (self._mapManager == null)
            {
                gAreaNum = 0;
                gAreaCnt = StageData[gStageNum].map_name.length;
                gMapLength.length = 0;
                gMapLengthTotal = 0;
                gPlayerMapPos = 0;
                for (var i=0; i<gAreaCnt; i++)
                {
                    var map = new cc.TMXTiledMap(StageData[gStageNum].map_name[i]);
                    var size = map.getMapSize().width * map.getTileSize().width;
                    gMapLength.push(size);
                    gMapLengthTotal += size;
                }
                gMapLengthTotal -=  map.getTileSize().width * 4;

                gStageType = StageData[gStageNum].stg_type[0];
                self._mapManager = new MapManager();
                self._ccb_bgLayer.addChild(self._mapManager, 0, 0);
                self._mapManager.init(StageData[gStageNum]);
                self._mapManager.start();
            }
                if (gStageType == 2) {
                        Spr_Player.getOrCreate(0);
                    }
                if (gStageType == 3) {
                        Spr_Player.getOrCreate(8);
                    }
                if (gStageType <= 1) {
                        Spr_Player.getOrCreate(1);
                    }

                                    
            self.pause();

            gSubStat++;
        }
        else if (gSubStat == 1)
        {
            if (self._fadeNode.controller._fadeOutFlag)
            {
                gSubStat++;
            }
        }
        else if (gSubStat == 2)
        {
            self._fadeNode.controller.init("fadein");
            gSubStat++;
        }
        else if (gSubStat == 3)
        {
            if (self._fadeNode.controller._fadeInFlag)
            {
                self._fadeNode = null;
                self.changeState(GAME_STATE.GS_START);
            }
        }
        break;

    case GAME_STATE.GS_START:

        if (gSubStat == 0)
        {
            var dialog = cc.BuilderReader.load(res.ccb_GameStart);
            self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMECLEAR);
            gSubStat++;
        }
        else if (gSubStat == 1)
        {

        }
        else if (gSubStat == 2)
        {
            gSoundManager.playBgm(StageData[gStageNum].sound, true);

            gWinFlag = false;
            gLoseFlag = false;
            gClearDemo = false;

            //self.draw_GameStart();
            //gSubStat++;

            if (!gSpecialStage) {
                gTryCount[gStageNum]++;
                if (gTryCount[gStageNum] >= MAX_TRY_COUNT) gTryCount[gStageNum] = MAX_TRY_COUNT;
            }
            else {
                gTryCount_SP[gStageNum]++;
                if (gTryCount_SP[gStageNum] >= MAX_TRY_COUNT) gTryCount_SP[gStageNum] = MAX_TRY_COUNT;
            }

            Utils.saveTryCount(gStageNum);

            self.changeState(GAME_STATE.GS_MAIN);

            self.resume();

            self.draw_startMessage();
        }
        self.updateUI();
        break;

    case GAME_STATE.GS_MAIN:
        var map = self._mapManager;

        if (gWinFlag)
        {
            self.changeState(GAME_STATE.GS_STAGECLEAR);
            break;
        }

        if (gLoseFlag)
        {
            self.changeState(GAME_STATE.GS_GAMEOVER);
            break;
        }
        self.updateUI();
        break;

    case GAME_STATE.GS_AREA_CLEAR:
        if (gSubStat == 0)
        {
            self.updateUI();
            if (gPlayer._mode == 0)
            {
                gPlayer.setupAreaClearDemo();
                Spr_Enemy.allDestroy();
                Spr_Bane.allDestroy();
                gSubStat++;
            }
        }
        else if (gSubStat == 1)
        {
            self.updateUI();
        }
        else if (gSubStat == 2)
        {
            // ワープポイントまで到着
            var opa = gPlayer._obj.controller._ccb_body.opacity -= 8;
           // var opa = gPlayer._obj.controller._ccb_body.opacity -= 8;
           // var opa = gPlayer._obj.controller._ccb_body.opacity -= 8;
            if (opa <= 0)
            {
                opa = 0;
                gSubStat++;
            }
            gPlayer._obj.controller._ccb_body.opacity = opa;
            gPlayer._obj.controller._kaban.opacity = opa;
      //      gPlayer._obj.controller._ccb_wing2.opacity = opa;
            
        }
        else if (gSubStat == 3)
        {
            gNewMap = new MapManager();
            self._ccb_bgLayer.addChild(gNewMap, 0, 0);
            gNewMap.x = 320;
            gAreaNum++;
            gNewMap.init(StageData[gStageNum]);
            gSubStat++;
        }
        else if (gSubStat == 4)
        {
            self._mapManager.x--;
            self._mapManager.x--;
            self._mapManager.x--;
            self._mapManager.x--;
            gNewMap.x--;
            gNewMap.x--;
            gNewMap.x--;
            gNewMap.x--;
            if (gNewMap.x <= 0)
            {
                gNewMap.x = 0;

                self._ccb_bgLayer.removeChild(self._mapManager);
                self._mapManager = null;
                self._mapManager = gNewMap;
                gNewMap = null;
                self._mapManager.start();
                gPlayer.x = 48;
                self.changeState(GAME_STATE.GS_MAIN);
                gClearDemo = false;
                gStageType = StageData[gStageNum].stg_type[gAreaNum];

                gPlayer._obj.controller._ccb_body.opacity  = 255;
                gPlayer._obj.controller._kaban.opacity  = 255;
            gPlayer._obj.controller._ccb_body.setAliasTexParameters();
//                gPlayer._obj.controller._ccb_wing1.setAliasTexParameters();
//                gPlayer._obj.controller._ccb_wing2.setAliasTexParameters();

                self.draw_startMessage();
            }
        }
        else if (gSubStat == 10)
        {
            // ゴール地点到着
            self.changeState(GAME_STATE.GS_STAGECLEAR);
        }
        break;

    case GAME_STATE.GS_STAGECLEAR:
        switch(gSubStat)
        {
        case 0:
            gSoundManager.playBgm(BGM.CLEAR, false);

            var map = self._mapManager;
            map.end();
            if (!gSpecialStage) {
                gDeadPoint[gStageNum][0] = cc.p(0,0);
                gDeadPoint[gStageNum][1] = 0;
            }
            else {
                gDeadPoint_SP[gStageNum][0] = cc.p(0,0);
                gDeadPoint_SP[gStageNum][1] = 0;
            }

            if (!gSpecialStage) gClearCount[gStageNum]++;
            else                gClearCount_SP[gStageNum]++;
            Utils.saveClearCount(gStageNum);
            Utils.saveDeadPoint(gStageNum);
            //gSoundManager.stopBgm();
            self._frameCounter = 2.0;
            gSubStat++;
            break;
        case 1:
            self._frameCounter -= dt;
            if (self._frameCounter <= 0)
            {
                if (gExtraLifeFlag)
                {
                    gExtraLifeFlag = false;
                    gSubStat = 20;
                }
                else
                {
                    var dialog = cc.BuilderReader.load(res.ccb_GameClear);
                    self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMECLEAR);
                    gSubStat++;
                }
            }
            break;
        case 2:
            break;
        case 10:
            break;

        case 20:
            // エクストラライフで動画広告
         //   self.useExtraLife();
            gSubStat++;
            break;
        case 21:
            break;
        case 22:
            var dialog = cc.BuilderReader.load(res.ccb_GameClear);
            self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMECLEAR);
            gSubStat = 2;
            break;
        }
        break;


    case GAME_STATE.GS_GAMEOVER:

        switch(gSubStat)
        {
        case 0:
            var map = self._mapManager;
            map.end();
            gSoundManager.playBgm(BGM.GAMEOVER, false);

            self._frameCounter = 2.5;
            gSubStat++;
            break;
        case 1:
            self._frameCounter -= dt;
            if (self._frameCounter <= 0)
            {
                self._frameCounter = 0;

                if (gExtraLifeFlag)
                {
                    // エクストラライフ使ってるので動画流す
                    gExtraLifeFlag = false;
                    gSubStat = 30;
                }
                else
                {
                    gSubStat++;
                }
            }
            break;

        case 2:
            // エクストラライフダイアログ出すか？
            var cp = self.searchCheckPoint();
            if (cp != null )//&& Utils.checkNetworkConnect())
            {
                gExtraMapPos = -(cp.x - 1) * g_sharedGameScene._mapManager._tilesize.width;
                gExtraAreaNum = gAreaNum;
                gExtraPlayerMode = 0;
                gExtraPlayerJumpFlag = false;
                gExtraPlayerAnime = "walk";
                var p = g_sharedGameScene._mapManager.convertToMapPos(cp);
                gExtraPlayerPos = cc.p(48, p.y);

                var min = videoAdsParam.Extra.min;
                var max = videoAdsParam.Extra.max +1;
                var off = Math.floor(Math.random() * (max - min));
                off += min;
                r = Math.floor(Math.random() * off);

                                    r=0;
                if (r != 0)
                {
                    var dialog = cc.BuilderReader.load(res.ccb_GameOver);
                    self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMEOVER);
                    gSubStat++;
                }
                else
                {
                    var dialog = cc.BuilderReader.load(res.ccb_ExtraLife);
                    self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMEOVER);
                    gSubStat = 20;
                }
            }
            else
            {
                var dialog = cc.BuilderReader.load(res.ccb_GameOver);
                self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMEOVER);
                gSubStat++;
            }
            break;
        case 3:
            break;

        // リトライ
        case 10:
            if (gHeartGet)
            {
                //gHeartGet = false;
                self.changeState(GAME_STATE.GS_CONTINUE);
            }
            else
            {
                // 通常リトライ
                gContinueFlag=2;
                var aboutNode = cc.BuilderReader.load(res.ccb_Fade);
                aboutNode.controller.setDelegate(this);
                self._ccb_dialogLayer.addChild(aboutNode, Z_ORDER.FADE, LAYER_TAG.FADE);
                aboutNode.controller.init("fadeout");
                self._fadeNode = aboutNode;
                gSubStat++;
                    
            }
            break;
        case 11:
            if (self._fadeNode.controller._fadeOutFlag)
            {
                // 通常リトライ
                self.exitGame();
                self.changeState(GAME_STATE.GS_INIT);
                gContinueFlag = 0;  // 0: 通常リトライ
                            
            }
            break;
        case 12:
            break;

        // エクストラライフ使うか？ダイアログ表示
        case 20:
            break;
        case 21:
            // 使わない
            var dialog = cc.BuilderReader.load(res.ccb_GameOver);
            self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMEOVER);
            gSubStat = 3;
            break;
        case 22:
            // 使う
          //  gExtraLifeFlag = true;
            gContinueFlag = 2;      // 2: EXTRAポイントでコンティニュー

                var aboutNode = cc.BuilderReader.load(res.ccb_Fade);
                aboutNode.controller.setDelegate(this);
                self._ccb_dialogLayer.addChild(aboutNode, Z_ORDER.FADE, LAYER_TAG.FADE);
                aboutNode.controller.init("fadeout");
                self._fadeNode = aboutNode;
                gSubStat++;
                break;
            case 23:
                if (self._fadeNode.controller._fadeOutFlag)
                {
                    gSubStat++;
                }
                break;

            case 24:
                Spr_Enemy.allDestroy();
                Spr_Bane.allDestroy();

                self._ccb_bgLayer.removeChild(self._mapManager);
                self._mapManager = null;
                gAreaNum = gExtraAreaNum;
                gStageType = StageData[gStageNum].stg_type[gAreaNum];
                self._mapManager = new MapManager();
                self._ccb_bgLayer.addChild(self._mapManager, 0, 0);
                self._mapManager.init(StageData[gStageNum]);
                self._mapManager.restart(gExtraMapPos);
                gPlayer.restart_extrapoint();
                self.pause();

                self._fadeNode.controller.init("fadein");
                gSubStat++;
                break;

            case 25:
                if (self._fadeNode.controller._fadeInFlag)
                {
                    self.changeState(GAME_STATE.GS_START);
                    self._fadeNode = null;
                    //self.resume();
                }
                break;
        // エクストラライフ使ってるので動画流す
        case 30:
            // エクストラライフで動画広告
       //     self.useExtraLife();
            gSubStat++;
            break;
        case 31:
            break;
        case 32:
            //エクストラ抽選する場合はこっち - gSubStat = 2;
            //エクストラ動画観たあとはエクストラ抽選しない場合 ↓
            var dialog = cc.BuilderReader.load(res.ccb_GameOver);
            self._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMEOVER);
            gSubStat = 3;
            break;
        }
        break;

    // コンティニュー
    case GAME_STATE.GS_CONTINUE:
        switch(gSubStat)
        {
        case 0:
            var aboutNode = cc.BuilderReader.load(res.ccb_Fade);
            aboutNode.controller.setDelegate(this);
            self._ccb_dialogLayer.addChild(aboutNode, Z_ORDER.FADE, LAYER_TAG.FADE);
            aboutNode.controller.init("fadeout");
            self._fadeNode = aboutNode;
            gContinueFlag = 1;      // 1: セーブポイントでコンティニュー
            gSubStat++;
            break;
        case 1:
            if (self._fadeNode.controller._fadeOutFlag)
            {
                gSubStat++;
            }
            break;

        case 2:
            Spr_Enemy.allDestroy();
            Spr_Bane.allDestroy();

            self._ccb_bgLayer.removeChild(self._mapManager);
            self._mapManager = null;
            gAreaNum = gSaveAreaNum;
            gStageType = StageData[gStageNum].stg_type[gAreaNum];
            self._mapManager = new MapManager();
            self._ccb_bgLayer.addChild(self._mapManager, 0, 0);
            self._mapManager.init(StageData[gStageNum]);
            self._mapManager.restart(gSaveMapPos);
            gPlayer.restart_savepoint();
            self.pause();

            self._fadeNode.controller.init("fadein");
            gSubStat++;
            break;

        case 3:
            if (self._fadeNode.controller._fadeInFlag)
            {
                self.changeState(GAME_STATE.GS_START);
                self._fadeNode = null;
                //self.resume();
            }
            break;
        }
        break;

    case GAME_STATE.GS_EXIT :
        switch(gSubStat)
        {
        case 0:
            // タイトル画面に戻る
            Utils.hideBannerView();
            var scene = cc.BuilderReader.loadAsScene(res.ccb_Title);
            cc.director.runScene(cc.TransitionFade.create(0.5, scene));
            gSubStat++;
            break;
        case 1:
            break;
        }
        break;
    }

},

// エクストラライフ使ってるので動画流す
useExtraLife : function()
{
    // ネットワークエラーチェック
    if (Utils.checkNetworkConnect())
    {
        // 動画広告選択
        var v1 = videoAdsParam.AdColony;
        var v2 = videoAdsParam.Maio + v1;
        var v3 = videoAdsParam.UnityAds + v2;
        var r = Math.floor(Math.random() * v3);
        var f = true;
        if (r < v1) {
            // AdColony
            if (Utils.isV4VCRewardAvailable())
            {
       //         Utils.showV4VCVideo(this);
            }
            else
            {
                // Maio か UnityAds か選択
                var v2 = videoAdsParam.Maio;
                var v3 = videoAdsParam.UnityAds + v2;
                var r = Math.floor(Math.random() * v3);
                if (r < v2 && Utils.isShowMaio())
                {
         //           Utils.showMaio(this);
                }
                else if (Utils.isShowUnityAds())
                {
          //          Utils.showUnityAds(this);
                }
                else
                {
                    f = false;
                }
            }
        }
        else if (r < v2)
        {
            // Maio
            if (Utils.isShowMaio())
            {
       //         Utils.showMaio(this);
            }
            else
            {
                // AdColony か UnityAds か選択
                var v1 = videoAdsParam.AdColony;
                var v3 = videoAdsParam.UnityAds + v1;
                var r = Math.floor(Math.random() * v3);

                if (r < v1 && Utils.isV4VCRewardAvailable())
                {
         //           Utils.showV4VCVideo(this);
                }
                else if (Utils.isShowUnityAds())
                {
            //        Utils.showUnityAds(this);
                }
                else
                {
                    f = false;
                }
            }
        }
        else
        {
            // UnityAds
            if (Utils.isShowUnityAds())
            {
      //          Utils.showUnityAds(this);
            }
            else
            {
                // AdColony か Maio か選択
                var v1 = videoAdsParam.AdColony;
                var v2 = videoAdsParam.Maio + v1;
                var r = Math.floor(Math.random() * v2);

                if (r < v1 && Utils.isV4VCRewardAvailable())
                {
        //            Utils.showV4VCVideo(this);
                }
                else if (Utils.isShowMaio())
                {
           //         Utils.showMaio(this);
                }
                else
                {
                    f = false;
                }
            }
        }

        if (!f)
        {
            // 動画在庫切れ
            gSubStat++;
        }
    }
    else
    {
        gSubStat++;
    }
},
getRewardVideo : function(flg)
{
    gSubStat++;
    gSoundManager.resume();
},

// 最寄りのチェックポイントを探す
searchCheckPoint : function()
{
    var cp = cc.p(0,0);

    if (gCheckPointList.length == 0) return null;

    var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
    pos = g_sharedGameScene._mapManager.convertToTileMapPos(pos);

    var id = 0;
    for (id=0; id<gCheckPointList.length; id++)
    {
        cp = gCheckPointList[id];
        if (cp.x > pos.x) break;
    }
    id--;
    if (id < 0) {
         return null;
     }
    cp = gCheckPointList[id];
    return cp;
},
//-----------------------------------------------------------------------------
//  エリアクリア
//-----------------------------------------------------------------------------
setupAreaClearDemo : function()
{
    // 死亡中？
    if (gPlayer._mode == 2) return;
    gClearDemo = true;
    this.touchCancel();
    gPlayer._vy = -100;
    this.changeState(GAME_STATE.GS_AREA_CLEAR);
},
//=============================================================================
//  ステージ初期設定
//=============================================================================
createStageBG : function()
{
/*
    var viewSize = this._ccb_bgLayer.getContentSize();

    // BG画像貼り合わせる
    var bg_contents = cc.Node.create();
    var stageData = Levels[gStageNum];
    var map_width = stageData.width;
    var bg = cc.Sprite.create(stageData.bg);
    var w = bg.getContentSize().width;
    var map_height = bg.getContentSize().height;

    bg = null;
    var x = 0;
    while(true)
    {
        bg = cc.Sprite.create(stageData.bg);
        bg.attr({
            x: x,
            y: 0,
            anchorX: 0,
            anchorY: 0,
        });

        bg.x = x;
        bg_contents.addChild(bg);
        x += w;
        if (x >= map_width) break;
    }
    this._scrollViewContentSize = cc.size(map_width, map_height);
    bg_contents.setContentSize(this._scrollViewContentSize);

*/

},

//=============================================================================
//  描画関係
//=============================================================================
updateUI : function ()
{
    if (gPlayer != null)
    {
        var total = 0;
        var pos = this._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
        var x = pos.x;
        for (var i=0; i<gAreaNum; i++)
        {
            x += gMapLength[i];
        }

        var len = x / gMapLengthTotal;
        if (len > 1.0) len = 1.0;
        this._gauge_length.setScaleX(len);
        len *= 100;
        len = Math.floor(len);
        this._label_length.setString(""+len+"%");
        gAchievement = len;
    }
},

openSavePointDialog : function()
{
    gPauseNow = true;
    this.pause();
    var dialog = cc.BuilderReader.load(res.ccb_SavePoint);
    this._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.SAVEPOINT);
},

draw_startMessage : function()
{
    var dialog = null;
    if (gStageType == 0)
    {
        dialog = cc.BuilderReader.load(res.ccb_StartMsg1);
    }
    else if (gStageType == 1)
    {
        dialog = cc.BuilderReader.load(res.ccb_StartMsg2);
    }
    else if (gStageType == 2)
    {
        dialog = cc.BuilderReader.load(res.ccb_StartMsg3);
    }
    else
    {
        dialog = cc.BuilderReader.load(res.ccb_StartMsg4);
    }
    dialog.x = 160;
    dialog.y = 500;
    this._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.GAMECLEAR);

    //this._sttmsgNode = dealog;

},

//=============================================================================
//
//=============================================================================
changeState: function(state)
{
    gGameStat = state;
    gSubStat = 0;

    if (state != GAME_STATE.GS_MAIN )
    {
        gPauseEnable = false;
    }

    if (state == GAME_STATE.GS_MAIN)
    {
        gTouchEnable = true;
        gPauseEnable = true;
    }

    if (state > GAME_STATE.GS_MAIN )
    {
        gTouchEnable = false;
    }
},
didEnterBackground : function()
{
    this.onPressedPause();
},
willEnterForeground : function()
{},

// ポーズボタン
onPressedPause: function()
{
    if (gPauseEnable && !gPauseNow)
    {
        gPauseNow = true;
        var dialog = cc.BuilderReader.load(res.ccb_Pause);
        this._ccb_dialogLayer.addChild(dialog);

        ///@11/11 this.rootNode.pauseSchedulerAndActions();
        //this.rootNode.pause();
        cc.director.getScheduler().pauseTarget(this.rootNode);

        this.pause();
    }
},
pause: function()
{
                    if (gRecordingNow) {
                            Utils.stopRec();
                        }
    gSoundManager.clearSEpoolTimer();

    var i = 0;
    var len = 0;

    this._mapManager.pause();

    gPlayer.pause();

    len = gEnemies.length;
    for(i=0; i<len; i++)
    {
        gEnemies[i].pause();
    }
    len = gBaneObj.length;
    for(i=0; i<len; i++)
    {
        gBaneObj[i].pause();
    }

},

resume : function()
{
        //if (gSound)
        //{
        //  gAudioEngine.resumeMusic();
        //}

    //@11/11 this.rootNode.resumeSchedulerAndActions();
    cc.director.getScheduler().resumeTarget(this.rootNode);

    var i = 0;
    var len = 0;

    gPlayer.resume();

    len = gEnemies.length;
    for(i=0; i<len; i++)
    {
        gEnemies[i].resume();
    }

    len = gBaneObj.length;
    for(i=0; i<len; i++)
    {
        gBaneObj[i].resume();
    }

    this._mapManager.resume();

    gPauseNow = false;
}
//=============================================================================
// end...
});

//*****************************************************************************
//  ゲームクリアレイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_GameClear", {

_pressedButton: false,

onDidLoadFromCCB : function()
{
    // クリアは強制的に１００％
                                    
                                    
                if (gRecordingNow) {
                                    Utils.stopRec();
                }
                                    
    gAchievement = 100;
                                    
    if (gStageType == 2) {
            var tex = cc.textureCache.addImage("logo/clear2.PNG");
            this._clr_logo.setTexture(tex);
    }

    if (gStageType == 3) {
        var tex = cc.textureCache.addImage("logo/clear3.PNG");
        this._clr_logo.setTexture(tex);
                                    
    }
    //this.rootNode.animationManager.setCompletedAnimationCallback(this, this.onAnimationComplete);
    this._pressedButton = false;
    var cnt;
    if (!gSpecialStage) cnt = gTryCount[gStageNum];
    else                cnt = gTryCount_SP[gStageNum];
    this._try_counter.setString(""+cnt+" 回");
    this._achievement.setString(""+gAchievement+"%");
},
onPressedBack : function()
{
    if (this._pressedButton) return;
    this._pressedButton = true;

    gSoundManager.playSE(SE.BTN_TAP);

    var parent = this.rootNode.getParent();
    parent.removeChild(this.rootNode, true);

    g_sharedGameScene.changeState(GAME_STATE.GS_EXIT);
},
onPressedTweet : function()
{
    if (this._pressedButton) return;
    this._pressedButton = true;

    gSoundManager.playSE(SE.BTN_TAP);

    Utils.postToTwitter(this);
    this._pressedButton = false;
                                    
},
getRewardTwitter : function(flg)
{
    if (flg)
    {
        // リワード受け取る。
        Utils.log("投稿！！")
    }
    this._pressedButton = false;
}
//=============================================================================
// end...
});

//*****************************************************************************
//  ゲームオーバーロゴレイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_GameOver", {

    _animeMng:null,
_pressedButton: false,

onDidLoadFromCCB : function()
{
    this._pressedButton = false;
                                    
    if (gRecordingNow) {
                    Utils.stopRec();
    }

    if (!gSpecialStage) cnt = gTryCount[gStageNum];
    else                cnt = gTryCount_SP[gStageNum];
    this._try_counter.setString(""+cnt+" 回");
    this._achievement.setString(""+gAchievement+"%");

    //Utils.showBannerView();
  //  Utils.showRectangleView();
            this._animeMng = this.rootNode.animationManager;
    if (gStageType == 2) {
    this._animeMng.runAnimationsForSequenceNamed("over_toki");
        }
    if (gStageType == 3) {
    this._animeMng.runAnimationsForSequenceNamed("over_arai");
    }
    if (gStageType <= 1) {
    this._animeMng.runAnimationsForSequenceNamed("over_serval");
    }
                                    
                                    
    //this.rootNode.animationManager.setCompletedAnimationCallback(this, this.onAnimationComplete);
},
// onAnimationComplete : function()
// {
//     if (gSubStat == 2)
//     {
//         gSubStat++;
//         //gTouchEnable = true;
//     }
// },
onPressedTitle : function()
{
    if (this._pressedButton) return;
    this._pressedButton = true;

    gSoundManager.playSE(SE.BTN_TAP);

    //Utils.hideBannerView();
    Utils.hideRectangleView();
    var parent = this.rootNode.getParent();
    parent.removeChild(this.rootNode, true);
    g_sharedGameScene.changeState(GAME_STATE.GS_EXIT);
},
onPressedRetry : function()
{
    if (this._pressedButton) return;
    this._pressedButton = true;

    gSoundManager.playSE(SE.BTN_TAP);

    //Utils.hideBannerView();
    Utils.hideRectangleView();
    var parent = this.rootNode.getParent();
    parent.removeChild(this.rootNode, true);
    gSubStat = 10;
}
//=============================================================================
// end...
});

//*****************************************************************************
//  エクストラライフレイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_ExtraLife", {

_mode : 0,
_pressedBack : false,
_pressedOK : false,
_counter:0,

onDidLoadFromCCB : function()
{
    this._mode = 0;
                                    gDobblejump =0;
    this._pressedBack = false;
    this._pressedOK = false;

                                    
            if (gRecordingNow) {
                        Utils.stopRec();
            }
                                    
    this._counter = 10;
    this._label_count.setString(""+gcontinueCount);
    this.rootNode.schedule(this.update, 1.0);
                                    
        // タッチ用リスナー
        this._touchListener = cc.EventListener.create({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: true,
                onTouchBegan: this.onTouchBegan,
        });
},
update : function(dt)
{
    var self = this.controller;

    if (self._counter > 0)
    {
        self._counter--;
        if (self._counter <= 0)
        {
            self._counter = 0;
            self.rootNode.unschedule(self.update);
        }
        self._label_count.setString(""+gcontinueCount);
    }
},
onTouchBegan : function(touch, event)
{
return true;
},
//=========================================================
// OKボタン
//=========================================================
onPressedOK : function()
{
    if (!this._pressedOK)
    {
        this._pressedOK = true;

        gSoundManager.playSE(SE.BTN_TAP);

        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);
        gSubStat = 22;
                                    
                        gcontinueCount -= 1;
                        if (gcontinueCount <=0) {
                                    gcontinueCount = 5;
                                    Utils.showRectangleView();
                                    
                        }
                                    
    }
},

//=========================================================
// 離脱ボタン
//=========================================================
onPressedBack : function()
{
    if (!this._pressedBack)
    {
        this._pressedBack = true;

        gSoundManager.playSE(SE.BTN_TAP);

        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);
        gSubStat = 21;
    }
}

//=============================================================================
// end...
});




//*****************************************************************************
//  セーブポイント確認用レイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_SavePoint", {

_delegate : null,
_mode : 0,
_pressedBack : false,
_pressedOK : false,

onDidLoadFromCCB : function()
{
    //gSoundManager.playSE(SE.DIALOG_OPEN);
    //this.rootNode.animationManager.setCompletedAnimationCallback(this, this.onAnimationComplete);
    this._mode = 0;
    this._pressedBack = false;
    this._pressedOK = false;
},

//=========================================================
// OKボタン
//=========================================================
onPressedOK : function()
{
    if (!this._pressedOK)
    {
        this._pressedOK = true;

        gSoundManager.playSE(SE.BTN_TAP);

        // ネットワークエラーチェック
        if (Utils.checkNetworkConnect())
        {
            // 動画広告選択
            var v1 = videoAdsParam.AdColony;
            var v2 = videoAdsParam.Maio + v1;
            var v3 = videoAdsParam.UnityAds + v2;
            var r = Math.floor(Math.random() * v3);
            Utils.log("v1:"+v1+" v2:"+v2+" v3:"+ v3+ "  r:"+r)
            var f = true;
            if (r < v1) {
                // AdColony
                Utils.log("振り分け- AdColony")
                if (Utils.isV4VCRewardAvailable())
                {
                    Utils.log("      -> AdColony")
            //        Utils.showV4VCVideo(this);
                }
                else
                {
                    // Maio か UnityAds か選択
                    var v2 = videoAdsParam.Maio;
                    var v3 = videoAdsParam.UnityAds + v2;
                    var r = Math.floor(Math.random() * v3);
                    Utils.log("     Maio か UnityAds か選択 -> v2:"+v2+" v3:"+ v3+ "  r:"+r)
                    if (r < v2 && Utils.isShowMaio())
                    {
                        Utils.log("      -> Maio")
                        Utils.showMaio(this);
                    }
                    else if (Utils.isShowUnityAds())
                    {
                        Utils.log("      -> UnityAds")
             //           Utils.showUnityAds(this);
                    }
                    else
                    {
                        f = false;
                    }
                }
            }
            else if (r < v2)
            {
                // Maio
                Utils.log("振り分け- Maio")
                if (Utils.isShowMaio())
                {
                    Utils.log("      -> Maio")
         //           Utils.showMaio(this);
                }
                else
                {
                    // AdColony か UnityAds か選択
                    var v1 = videoAdsParam.AdColony;
                    var v3 = videoAdsParam.UnityAds + v1;
                    var r = Math.floor(Math.random() * v3);
                    Utils.log("     AdColony か UnityAds か選択 -> v1:"+v1+" v3:"+ v3+ "  r:"+r)

                    if (r < v1 && Utils.isV4VCRewardAvailable())
                    {
                        Utils.log("      -> AdColony")
                //        Utils.showV4VCVideo(this);
                    }
                    else if (Utils.isShowUnityAds())
                    {
                        Utils.log("      -> UnityAds")
               //         Utils.showUnityAds(this);
                    }
                    else
                    {
                        f = false;
                    }
                }
            }
            else
            {
                // UnityAds
                Utils.log("振り分け- UnityAds")
                if (Utils.isShowUnityAds())
                {
                    Utils.log("      -> UnityAds")
          //          Utils.showUnityAds(this);
                }
                else
                {
                    // AdColony か Maio か選択
                    var v1 = videoAdsParam.AdColony;
                    var v2 = videoAdsParam.Maio + v1;
                    var r = Math.floor(Math.random() * v2);
                    Utils.log("     AdColony か Maio か選択 -> v1:"+v1+" v2:"+ v2+ "  r:"+r)

                    if (r < v1 && Utils.isV4VCRewardAvailable())
                    {
                        Utils.log("      -> AdColony")
             //           Utils.showV4VCVideo(this);
                    }
                    else if (Utils.isShowMaio())
                    {
                        Utils.log("      -> Maio")
                   //     Utils.showMaio(this);
                    }
                    else
                    {
                        f = false;
                    }
                }
            }

            if (!f)
            {
                // 動画在庫切れ
                this._pressedOK = false;
                var parent = this.rootNode.getParent();
                parent.removeChild(this.rootNode, true);

                var dialog = cc.BuilderReader.load(res.ccb_NetError);
                g_sharedGameScene._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.SAVEPOINT);
            }
        }
        else
        {
            this._pressedOK = false;
            var parent = this.rootNode.getParent();
            parent.removeChild(this.rootNode, true);

            var dialog = cc.BuilderReader.load(res.ccb_NetError);
            g_sharedGameScene._ccb_dialogLayer.addChild(dialog, 10, LAYER_TAG.SAVEPOINT);
        }
    }
},
getRewardVideo : function(flg)
{
    if (flg)
    {
        gHeartGet = true;

        // セーブ位置更新
        //var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
        //var mappos = g_sharedGameScene._mapManager.convertToTileMapPos(pos);
        gSaveMapPos = -g_sharedGameScene._mapManager._tilesize.width * (gHeartPos.x - 1);
        gSaveAreaNum = gAreaNum;
        gSavePlayerMode = 0;
        gSavePlayerJumpFlag = false;
        gSavePlayerAnime = "walk";
        var pos = g_sharedGameScene._mapManager.convertToMapPos(gHeartPos);
        gSavePlayerPos = cc.p(gPlayer.x, pos.y);
    }

    this._pressedOK = false;
    var parent = this.rootNode.getParent();
    parent.removeChild(this.rootNode, true);
    g_sharedGameScene.resume();

    gSoundManager.resume();
},
//=========================================================
// 離脱ボタン
//=========================================================
onPressedBack : function()
{
    if (!this._pressedBack)
    {
        this._pressedBack = true;

        gSoundManager.playSE(SE.BTN_TAP);

        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);
        g_sharedGameScene.resume();
    }
}

//=============================================================================
// end...
});


//*****************************************************************************
//  ネットワークエラー用レイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_NetError", {

_delegate : null,
_mode : 0,
_pressedOK : false,

onDidLoadFromCCB : function()
{
    this._mode = 0;
    this._pressedOK = false;
},

//=========================================================
// 再開ボタン
//=========================================================
onPressedBack : function()
{
    if (!this._pressedOK)
    {
        this._pressedOK = true;

        gSoundManager.playSE(SE.BTN_TAP);

        this._pressedOK = false;
        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);
        g_sharedGameScene.resume();
    }
}

//=============================================================================
// end...
});


//*****************************************************************************
//  フェードイン／アウト用レイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_Fade", {

_delegate : null,
_fadeOutFlag: false,
_fadeInFlag: false,

onDidLoadFromCCB : function()
{
    this._fadeOutFlag = false;
    this._fadeInFlag = false;

    this.rootNode.animationManager.setCompletedAnimationCallback(this, this.onAnimationComplete);
},

onAnimationComplete : function()
{
    var anmMng = this.rootNode.animationManager;
    var name = anmMng.getLastCompletedSequenceName();
    if( name == "fadein")
    {
        // シナリオWindow消去
        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);

        this._fadeInFlag = true;
    }
    if( name == "fadeout")
    {
        this._fadeOutFlag = true;
    }
},
setDelegate : function(delegate)
{
    this._delegate = delegate;
},
init : function(label)
{
    var anmMng = this.rootNode.animationManager;
    anmMng.runAnimationsForSequenceNamedTweenDuration(label, 0.0);
},
remove : function()
{
    var parent = this.rootNode.getParent();
    parent.removeChild(this.rootNode, true);
}

//=============================================================================
// end...
});

//*****************************************************************************
//  ポーズ用レイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_Pause", {

_delegate : null,
_mode : 0,
_pressedResume : false,
_pressedTitle : false,

onDidLoadFromCCB : function()
{
    //gSoundManager.playSE(SE.DIALOG_OPEN);

    //this.rootNode.animationManager.setCompletedAnimationCallback(this, this.onAnimationComplete);
    this._mode = 0;
    this._pressedResume = false;
    this._pressedTitle = false;

    //Utils.showBannerView();
  //  Utils.showRectangleView();
},

// onAnimationComplete : function()
// {
//     var anmMng = this.rootNode.animationManager;
//     var name = anmMng.getLastCompletedSequenceName();
//     if( name == "Outro")
//     {
//         var parent = this.rootNode.getParent();
//         parent.removeChild(this.rootNode, true);
//
//         if (this._pressedResume)
//         {
//             g_sharedGameScene.resume();
//             return;
//         }
//         else if (this._pressedTitle)
//         {
//             g_sharedGameScene.resume();
//             // ホーム画面に戻る
//             var scene = cc.BuilderReader.loadAsScene(res.ccb_Home);
//             cc.director.runScene(cc.TransitionFade.create(0.5, scene));
//             return;
//         }
//     }
// },

//=========================================================
// 再開ボタン
//=========================================================
onPressedResume : function()
{
    if (!this._pressedResume)
    {
        this._pressedResume = true;
        //this.rootNode.animationManager.runAnimationsForSequenceNamed("Outro");
        //gSoundManager.playSE(SE.DIALOG_OK);

        gSoundManager.playSE(SE.BTN_TAP);

        //Utils.hideBannerView();
        Utils.hideRectangleView();
        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);
        g_sharedGameScene.resume();
    }
},
//=========================================================
// 離脱ボタン
//=========================================================
onPressedTitle : function()
{
    if (!this._pressedTitle)
    {
        this._pressedTitle = true;

        gSoundManager.playSE(SE.BTN_TAP);

        Utils.hideRectangleView();
        Utils.hideBannerView();

        var scene = cc.BuilderReader.loadAsScene(res.ccb_Title);
        cc.director.runScene(cc.TransitionFade.create(0.5, scene));
    }
}

//=============================================================================
// end...
});

//*****************************************************************************
//  スタート画面レイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Layer_GameStart", {

_pressedStart : false,

onDidLoadFromCCB : function()
{
    this._pressedStart = false;
    this.start_text.setString(gStartMess[gStageType]);
},

//=========================================================
// 再開ボタン
//=========================================================
onPressedStart : function()
{
    if (!this._pressedStart)
    {
        this._pressedStart = true;
        gSoundManager.playSE(SE.BTN_TAP);

        var parent = this.rootNode.getParent();
        parent.removeChild(this.rootNode, true);
        gSubStat++;
    }
},
pushRec : function() {
        Utils.log("REC");
                                    Utils.startRec();
                                    //Utils.postToTwitter();
                                    this._pressedStart = true;
                                    gSoundManager.playSE(SE.BTN_TAP);
                                    
                                    var parent = this.rootNode.getParent();
                                    parent.removeChild(this.rootNode, true);
                                    gSubStat++;
},
pushLive : function() {
        Utils.log("LIVE");
                                    Utils.startLive();
                                    this._pressedStart = true;
                                    gSoundManager.playSE(SE.BTN_TAP);
                                    
                                    var parent = this.rootNode.getParent();
                                    parent.removeChild(this.rootNode, true);
                                    gSubStat++;
}

//=============================================================================
// end...
});


//*****************************************************************************
//  スタート画面レイヤー
//*****************************************************************************
cc.BuilderReader.registerController("Parts_StartMsg", {

onDidLoadFromCCB : function()
{
    this.rootNode.animationManager.setCompletedAnimationCallback(this, this.onAnimationComplete);
},

onAnimationComplete : function()
{
    var parent = this.rootNode.getParent();
    parent.removeChild(this.rootNode, true);
}
//=============================================================================
// end...
});
