

function SoundManager(bgmvol, sevol)
{
    this._bgmVol = bgmvol;
    this._seVol = sevol;
    this.setBgmVolume(bgmvol);
    this.setSEVolume(sevol);
    this._pause = false;
    this._bgmNum = -1;

    this._sePool = new Array(SoundEffectsData.length);
    this._isSePool = false;

	this._channel = new Array(SoundEffectsData.length);
/*
    // SEは先に読み込んでおく
    for (var i=0; i<SoundEffectsData.length; i++)
    {
    	cc.audioEngine.preloadEffect(SoundEffectsData[i]);
    }
*/
}

SoundManager.prototype.stopAll = function()
{
	this._bgmNum = -1;
	cc.audioEngine.stopMusic();
	cc.audioEngine.stopAllEffects();
	this.clearSEpoolTimer();
	this._isSePool = false;
}
SoundManager.prototype.stopBgm = function()
{
    this._bgmNum = -1;
	cc.audioEngine.stopMusic();
}
SoundManager.prototype.stopSE = function()
{
	cc.audioEngine.stopAllEffects();
}

SoundManager.prototype.isPlaying = function()
{
	return cc.audioEngine.isMusicPlaying();
}

SoundManager.prototype.pause = function()
{
	this._pause = true;
	cc.audioEngine.pauseMusic();
	cc.audioEngine.pauseAllEffects();
}

SoundManager.prototype.resume = function()
{
	this._pause = false;
	cc.audioEngine.resumeMusic();
	cc.audioEngine.resumeAllEffects();
}

SoundManager.prototype.playBgm = function(n, loop)
{
	if (n != this._bgmNum)
	{
		this._bgmNum = -1;
		cc.audioEngine.stopMusic();
		if ( n >= 0)
		{
			this._bgmNum = n;
			cc.audioEngine.playMusic(SoundMusicData[n], loop);
   		}
   	}
}

SoundManager.prototype.playBgmFile = function(name, loop)
{
	//if (n != this._bgmNum)
	//{
		this._bgmNum = -2;
		cc.audioEngine.stopMusic();
		//if ( n >= 0)
		//{
		//	this._bgmNum = n;
			cc.audioEngine.playMusic(name, loop);
   		//}
   	//}
}

SoundManager.prototype.playSE = function(n)
{
	if (this._isSePool)
	{
		if (this._sePool[n] > 0) return;
		this._sePool[n] = 2;
		this._channel[n] = cc.audioEngine.playEffect(SoundEffectsData[n], false);
	}
	else
	{
		this._channel[n] = cc.audioEngine.playEffect(SoundEffectsData[n], false);
	}
}
SoundManager.prototype.playSEFile = function(name)
{
	cc.audioEngine.playEffect(name, false);
}

SoundManager.prototype.getBgmVolume = function()
{
	return cc.audioEngine.getMusicVolume();
}
SoundManager.prototype.setBgmVolume = function(v)
{
	this._bgmVol = v;
	return cc.audioEngine.setMusicVolume(v);
}

SoundManager.prototype.getSEVolume = function()
{
	return cc.audioEngine.getEffectsVolume();
}
SoundManager.prototype.setSEVolume = function(v)
{
	this._seVol = v;
	return cc.audioEngine.setEffectsVolume(v);
}

SoundManager.prototype.setSePoolEnable = function(f)
{
	this._isSePool = f;
}
SoundManager.prototype.clearSEpoolTimer = function()
{
	var len = this._sePool.length;
	for(var i=0; i<len; i++)
	{
		this._sePool[i] = 0;
	}
}
SoundManager.prototype.countDownSEpoolTimer = function()
{
	var len = this._sePool.length;
	for(var i=0; i<len; i++)
	{
		if (this._sePool[i] == 0) continue;
		this._sePool[i]--;
	}
}
