var Spr_Bane = Sprite.extend(
{
    // コンストラクタ
    ctor:function (i)
    {
        this._super();
        this.setTag(i);
    },

    setParam: function(pos)
    {
        this.x = pos.x;
        this.y = pos.y;
        this._speed =  0;
        this._vx = 0;
        this._vy = 0;
        this._mode = 0;
                             
        this.setupAnimation("stop", false);
    },

    // 毎フレーム更新処理
    update:function (dt)
    {
        var _dt = gFrameRate
        
        this._super();

        if (!this._active || gGameStat != GAME_STATE.GS_MAIN) return;

        var pos = g_sharedGameScene._mapManager.convertMapToScreenPos(cc.p(this.x, this.y));

        if (this._mode == 0)
        {
            if (pos.x <= gWinSize.width)
            {
                this._mode++;
            }
        }
        else
        {
            if (pos.x < -32)
            {
                // 画面外なので消去
                this.destroy();
                return;
            }

            //--------------------
            // プレイヤーとの当たり判定
            //--------------------
            if (this._mode != 1) return;

            var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
            var aRect = cc.rect(pos.x + gPlayer._hitArea.x,
                                pos.y + gPlayer._hitArea.y,
                                gPlayer._hitArea.width,
                                gPlayer._hitArea.height);

            var bRect = cc.rect(this.x + this._hitArea.x,
                                this.y + this._hitArea.y,
                                this._hitArea.width,
                                this._hitArea.height);
            if (cc.rectIntersectsRect(aRect, bRect))
            {
                // Player 大ジャンプ
                gPlayer.setBigJump();
                this.setupAnimation("jump", false);
                this._mode = 2;
            }
        }
    }
});

Spr_Bane.allDestroy = function()
{
    var selChild = null;
    var len = gBaneObj.length;
    for (var j=0; j<len; j++)
    {
        selChild = gBaneObj[j];
        if (selChild._active)
        {
            selChild.destroy();
            var parent = selChild.getParent();
            parent.removeChild(selChild,true);
        }
    }
    gBaneObj.length = 0;
}
//************************************
//  ユニットを登録
//************************************
Spr_Bane.getOrCreate = function(num, pos, map)
{
    var selChild = null;
    selChild = new Spr_Bane(gBaneObj.length+1);
    map.addChild(selChild);
    selChild.born(SpriteData[num], num);
    selChild.schedule(selChild.update);
    selChild.setParam(pos);
    gBaneObj.push(selChild);
    return selChild;
};
