var Spr_Enemy = Sprite.extend(
{
    _eraseTimerBase: 0,
    _eraseTimerCur: 0,
    _eraseTimerWork: 0,

    // コンストラクタ
    ctor:function (i)
    {
        this._super();
        this.setTag(i);
    },

    setParam: function(pos)
    {
        this.x = pos.x;
        this.y = pos.y;
        this._speed =  0;
        this._vx = 0;
        this._vy = 0;
        this._mode = 0;

        if (this._type == 1)
        {
            this._eraseTimerBase = Math.random() + 5.25;
            this._eraseTimerCur = this._eraseTimerBase;
            this._eraseTimerWork = 0;
        }
    },

    // 毎フレーム更新処理
    update:function (dt)
    {
        this._super();

        var _dt = gFrameRate;

        if (!this._active || gGameStat != GAME_STATE.GS_MAIN) return;

        // お化け
        if (this._type == 1 && this._mode == 0)
        {
            var pos = g_sharedGameScene._mapManager.convertMapToScreenPos(cc.p(this.x, this.y));
            if (pos.x <= gWinSize.width)
            {
                this._mode++;
            }
            else return;
        }
        // 砲弾
        if (this._type == 2 && this._mode == 0)
        {
            var pos = g_sharedGameScene._mapManager.convertMapToScreenPos(cc.p(this.x, this.y));
            if (pos.x <= gWinSize.width)
            {
                this._mode++;
                this._vx = -HOUDAN_SPEED;
            }
            else return;
        }

        this.move(_dt);
    },
    move : function(dt)
    {
        var map = g_sharedGameScene._mapManager;
        var mapx = -map._tileMap.x;
        var oldx = this.x;
        var oldy = this.y;

        this.x += (this._vx * dt);
        this.y += (this._vy * dt);

        var scrPos = g_sharedGameScene._mapManager.convertMapToScreenPos(cc.p(this.x, this.y));
        if (scrPos.x < -32)
        {
            // 画面外なので消去
            this.destroy();
        }

        // お化け
        if (this._type == 1)
        {
            if (this._mode == 1)
            {
                var plypos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
                var x = this.x - plypos.x;
                var y = this.y - plypos.y;
                if ( y< 0 ) y *= -1;
                if (x < 200 && y < 180)
                {
                    //this._eraseTimerCur -= dt;
                    //if (this._eraseTimerCur <= 0)
                    //{
                        this._mode++;
                    //}
                }
            }
            else if (this._mode == 2)
            {
                this._obj.opacity -= 10;
                if (this._obj.opacity <= 10)
                {
                    this._obj.opacity = 0;
                    this._mode++;
                    this._eraseTimerCur = 0.3 + Math.random();
                }
            }
            else if (this._mode == 3)
            {
                this._eraseTimerCur -= dt;
                if (this._eraseTimerCur <= 0)
                {
                    this._mode++;
                }
            }
            else if (this._mode == 4)
            {
                this._obj.opacity += 20;
                if (this._obj.opacity >= 255)
                {
                    this._obj.opacity = 255;
                    this._mode = 1;
                    this._eraseTimerCur = this._eraseTimerBase;
                }
            }
        }

        //--------------------
        // プレイヤーとの当たり判定
        //--------------------
        if (gPlayer._nodamageTime != 0) return;

        var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
        var aRect = cc.rect(pos.x + gPlayer._hitArea.x,
                            pos.y + gPlayer._hitArea.y,
                            gPlayer._hitArea.width,
                            gPlayer._hitArea.height);

        var bRect = cc.rect(this.x + this._hitArea.x,
                            this.y + this._hitArea.y,
                            this._hitArea.width,
                            this._hitArea.height);
        if (cc.rectIntersectsRect(aRect, bRect))
        {
            // Player HIT&死亡
            gPlayer.setDead();
        }
    },

});

Spr_Enemy.allDestroy = function()
{
    var selChild = null;
    var len = gEnemies.length;
    for (var j=0; j<len; j++)
    {
        selChild = gEnemies[j];
        if (selChild._active)
        {
            selChild.destroy();
            var parent = selChild.getParent();
            parent.removeChild(selChild,true);
        }
    }
    gEnemies.length = 0;
}
//************************************
//  ユニットを登録
//************************************
Spr_Enemy.getOrCreate = function(num, pos, map)
{
    var selChild = null;
    /*var len = gEnemies.length;

    for (var j=0; j<len; j++)
    {
        selChild = gEnemies[j];
        if (selChild._active == false)
        {
            selChild.born(SpriteData[num], num);
            selChild.schedule(selChild.update);
            selChild.setParam(pos);
            return;
        }
    }
*/
    selChild = new Spr_Enemy(gEnemies.length+1);
    map.addChild(selChild);
    selChild.born(SpriteData[num], num);
    selChild.schedule(selChild.update);
    selChild.setParam(pos);
    gEnemies.push(selChild);
    return selChild;
};
