var Spr_Heart = Sprite.extend(
{
    _mapx: 0,
    _mapy: 0,

    // コンストラクタ
    ctor:function ()
    {
        this._super();
        //this.setTag(i);
    },

    setParam: function(pos, mappos, bgLayer)
    {
        this.x = pos.x;
        this.y = pos.y;
        this._mode = 0;

        this._mapx = mappos.x;
        this._mapy = mappos.y

        // 復活ポイント検索
        var w = mappos.x;
        var h = mappos.y + 1;
        do {
            var id = bgLayer.getTileGIDAt(w, h);
            if (id >= TILE_CODE.GROUND)
            {
                break;
            }
            h++;
            if (g_sharedGameScene._mapManager._mapsize.height < h) return;
        }while(true)

        this._mapx = w;
        this._mapy = h-1;

        if (gContinueFlag == 1)
        {
            // セーブポイントでコンティニュー
            if (gHeartPos.x == this._mapx && gHeartPos.y == this._mapy )
            {
                this._mode = 0;
                this._active = false;
            }
        }
    },

    // 毎フレーム更新処理
    update:function (dt)
    {
        this._super();

        if (!this._active || gGameStat != GAME_STATE.GS_MAIN) return;

        var pos = g_sharedGameScene._mapManager.convertMapToScreenPos(cc.p(this.x, this.y));

        if (this._mode == 0)
        {
            if (pos.x <= gWinSize.width)
            {
                this._mode++;
            }
        }
        else
        {
            if (pos.x < -32)
            {
                // 画面外なので消去
                this.destroy();
                return;
            }

            //--------------------
            // プレイヤーとの当たり判定
            //--------------------
            if (this._mode != 1) return;

            var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(gPlayer.x, gPlayer.y));
            var aRect = cc.rect(pos.x + gPlayer._hitArea.x,
                                pos.y + gPlayer._hitArea.y,
                                gPlayer._hitArea.width,
                                gPlayer._hitArea.height);

            var bRect = cc.rect(this.x + this._hitArea.x,
                                this.y + this._hitArea.y,
                                this._hitArea.width,
                                this._hitArea.height);
            if (cc.rectIntersectsRect(aRect, bRect))
            {
                // 当たり！！
                this._mode = 2;
                gHeartPos = cc.p(this._mapx, this._mapy)
                g_sharedGameScene.openSavePointDialog();
                gSoundManager.playSE(SE.HEART);

                this._mode = 0;
                this._active = false;

                var parent = this.getParent();
                parent.removeChild(this, true);
            }
        }
    }
});

//************************************
//  ユニットを登録
//************************************
Spr_Heart.getOrCreate = function(num, pos, map, mappos, bgLayer)
{
    var selChild = null;
    selChild = new Spr_Heart();
    map.addChild(selChild, Z_ORDER.PLAYER-1, LAYER_TAG.HEART);
    selChild.born(SpriteData[num], num);
    selChild.schedule(selChild.update);
    selChild.attr({
        scaleX: 0.5,
        scaleY: 0.5
    });
    selChild.setParam(pos, mappos, bgLayer);
    return selChild;
};
