var Spr_Player = Sprite.extend(
{
    _delay: 0,
    _gravity : 20,

    // コンストラクタ
    ctor:function (i)
    {
        this._super();
        this.setTag(i);
    },

    setParam: function(no)
    {
        this.x = 48;
        this.y = 300;
                               
        this._speed = 1.0;
        this._nodamageTime = 0;
        this._gravity = GRAVITY;
                               

        var map = g_sharedGameScene._mapManager;
        for(var h=0; h<map._mapsize.height; h++)
        {
            k = map._bgLayer.getTileGIDAt(cc.p(1,h));
            if (k >= TILE_CODE.GROUND)
            {
                h--;
                var pos = map.convertToMapPos(cc.p(1,h));
                this.y = pos.y;
                break;
            }
        }
    },

    // 毎フレーム更新処理
    update:function (dt)
    {
        this._super();

        var _dt = gFrameRate;

        if (gGameStat < GAME_STATE.GS_MAIN || !this._active) return;

        if (this._nodamageTime != 0.0)
        {
            this._temp0++;
            if ((this._temp0 & 2) != 0) this.visible = false;
            else this.visible = true;

            this._nodamageTime -= _dt;
            if (this._nodamageTime <= 0)
            {
                this._nodamageTime = 0.0;
                this.visible = true;
            }
        }

        if (gWinFlag || gLoseFlag)
        {
            this.move(_dt);
            return;
        }

        if (gJumpFlag)
        {
            gJumpFlag = false;
            switch(gStageType)
            {
            case 0:
                if (this._mode == 0)
                {
                    this.setJump();
                }
                break;
            case 1:
                this.setJump2();
                break;
            case 2:
                if (this._mode != 2)
                {
                    gJumpFlag = true;
                    if (this._mode == 0)
                    {
                        this.setFly();
                    }
                    this._vy += REPULSION;
                    if (this._vy >= REPULSION_MAX) this._vy = REPULSION_MAX;
                }
                break;
            case 3:
                if (gDobblejump < 2)
                {
                            if (this._mode == 0 && gDobblejump == 0) {
                               gDobblejump += 1;
                               this.setJump();
                            } else {
                               this.setJump2();
                            }
        
                }
                break;
            default:
                break;
            }
        }
        this.move(_dt);
    },
    move : function(dt)
    {
        if (this._mode == 3) return;

        var map = g_sharedGameScene._mapManager;
        var mapx = -map._tileMap.x;
        var oldx = this.x;
        var oldy = this.y;

        this.x += Math.ceil(this._vx * dt)
        this._vy -= Math.ceil(this._gravity * dt);
        var limit = 0;
        limit = -FALL_SPEED_MAX_FLY;
        if (gStageType != 2) limit = -FALL_SPEED_MAX;
        if (this._vy < limit) this._vy = limit;
        this.y += Math.ceil(this._vy * dt);

        if (this._mode == 2)
        {
            // 死亡中
            if (this.y < -240)
            {
                this.y = -360;
                this._active = false;
                this.pause();
            }
            return;
        }

        if (this.y <= 0)
        {
            if (this.y <= -120) {
                this.y = -340;
                this.setDead();
            }
            return;
        }

        //--------------------
        // 足元チェック
        //--------------------
        var chip = 0;
        var x = 0;
        var y = this.y;
        var hitWidth = this._hitArea.width;
        var hitHeight = this._hitArea.height;
        for (var i=0; i<2; i++)
        {
            if (i == 0)
            {
                x = this.x - hitWidth + 1;
            }
            else
            {
                x = this.x + hitWidth - 1;
            }
            chip = map.getBgTileNum(mapx + x, y);

            if (chip >= TILE_CODE.DAMAGE && chip < TILE_CODE.NOHIT && this._nodamageTime == 0 && gGameStat == GAME_STATE.GS_MAIN)
            {
                // 地面＆死亡
                this.setDead();
                return;
            }
            else if (chip != 0 && chip < TILE_CODE.NOHIT)   //判定追記
            {
                // 地面
                this._vy = 0;
                var h = map._tilesize.height;
                var new_y = parseInt(y / h, 10);
                y = (new_y+1) * h;
                chip = map.getBgTileNum(mapx + x, y);
                if (chip >= TILE_CODE.DAMAGE && chip < TILE_CODE.NOHIT && this._nodamageTime == 0 && gGameStat == GAME_STATE.GS_MAIN)
                {
                    // 地面＆死亡
                    this.setDead();
                    return;
                }

                this.y = y;
                this._mode = 0;
                gDobblejump = 0;
                this.setupAnimation("walk", false);

                break;
            }
        }

        //--------------------
        // 頭上チェック
        //--------------------
        y = this.y + hitHeight;
        for (var i=0; i<2; i++)
        {
            if (i == 0)
            {
                x = this.x - hitWidth + 1;
            }
            else
            {
                x = this.x + hitWidth - 1;
            }
            if (y >= map._mapHeight)
            {
                // 天井
                this._vy = 0;
                this.y = oldy;
                break;
            }
            if (y >= map._mapHeight) continue;
            chip = map.getBgTileNum(mapx + x, y);
            if (chip >= TILE_CODE.DAMAGE && chip < TILE_CODE.NOHIT && this._nodamageTime == 0 && gGameStat == GAME_STATE.GS_MAIN)
            {
                // ダメージ床
                // 地面＆死亡
                this.setDead();
                return;
            }
            else if (chip != 0 && chip < TILE_CODE.NOHIT)   //判定追記
            {
                // 天井
                this._vy = 0;
                this.y = oldy;
                break;
            }
        }
        //--------------------
        // 壁チェック
        //--------------------
        x = this.x + hitWidth;
        for (var i=0; i<2; i++)
        {
            if (i == 0) y = this.y + 1;
            else y = this.y + hitHeight - 1;

            if (y >= map._mapHeight) continue;

            chip = map.getBgTileNum(-map._tileMap.x + x, y);

            if (this._nodamageTime != 0)
            {
                // 無敵中
                if (chip >= TILE_CODE.DAMAGE)
                {
                    continue;
                }
            }
            if (chip != 0 && chip < TILE_CODE.NOHIT && gGameStat == GAME_STATE.GS_MAIN)
            {
                // 地面＆死亡
                this.setDead();
                return;
            }
        }

        if (gGameStat == GAME_STATE.GS_MAIN && this._animeName == "walk")
        {
            this._counter++;
            this._counter &= 3;
            if (this._counter == 0)
            {
          //      gSoundManager.playSE(SE.RUN);
            }
        }
    },
    setJump : function()
    {
        gSoundManager.playSE(SE.JUMP);
        this._mode = 1;
        this._vy = JUMP_POWER;
        this._gravity = GRAVITY;
        this.setupAnimation("jump", false);
    },
    setJump2 : function()
    {
        gSoundManager.playSE(SE.JUMP);
        this._mode = 1;
        gDobblejump +=1;
        this._vy = JUMP_POWER;
        this._gravity = GRAVITY;
        this.setupAnimation("jump2", false);

        var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(this.x, this.y));
        var node = cc.Sprite.create("efect01.png");
        node.x = pos.x;
        node.y = pos.y;
        g_sharedGameScene._mapManager._tileMap.addChild(node);
        var fin = cc.FadeTo.create(0.3, 0);
        node.runAction(cc.Sequence.create(fin, cc.CallFunc.create(
        function(){
            var parent = node.getParent();
            parent.removeChild(node, true);
        }, node)));
    },
    setBigJump : function()
    {
        gSoundManager.playSE(SE.BANE);
        this._mode = 1;
        this._vy = JUMP_POWER_BANE;
        this._gravity = GRAVITY;
        this.setupAnimation("jump", false);
    },
    setFly : function()
    {
        this._mode = 1;
        this._vy = JUMP_POWER_FLY;
        this._gravity = GRAVITY_FLY;
     //   this._ccb_body.getTexture().setAliasTexParameters();
        this.setupAnimation("fly", false);
    },
    setDead : function()
    {
        gSoundManager.playSE(SE.DEAD);
        this._mode = 2;
        this._vy = JUMP_POWER_DEAD;
        this._gravity = GRAVITY_DEAD;
        this.setupAnimation("dead", false);
        gLoseFlag = true;

        var pos = g_sharedGameScene._mapManager.convertScreenToWorldPos(cc.p(this.x, this.y));
        var deadP;
        if (!gSpecialStage) deadP = gDeadPoint;
        else                deadP = gDeadPoint_SP;
        if (gAreaNum > deadP[gStageNum][1] || (gAreaNum == deadP[gStageNum][1] && pos.x > deadP[gStageNum][0].x))
        {
            deadP[gStageNum][0] = pos;
            deadP[gStageNum][1] = gAreaNum;
            Utils.saveDeadPoint(gStageNum);
        }
    },
    setWin : function()
    {
        this._mode = 3;
        this.setupAnimation("win", false);
    },

    restart_savepoint : function()
    {
        this._mode = gSavePlayerMode;
        gJumpFlag = gSavePlayerJumpFlag;
        this._vy = 0;
        this._active = true;
        this.setupAnimation(gSavePlayerAnime, false);
        this.x = gSavePlayerPos.x;
        this.y = gSavePlayerPos.y;
        this._gravity = GRAVITY;
        this.resume();

        this._nodamageTime = 2.0;
    },
    restart_extrapoint : function()
    {
        this._mode = gExtraPlayerMode;
        gJumpFlag = gExtraPlayerJumpFlag;
        this._vy = 0;
        this._active = true;
        this.setupAnimation(gExtraPlayerAnime, false);
        this.x = gExtraPlayerPos.x;
        this.y = gExtraPlayerPos.y;
        this._gravity = GRAVITY;
        this.resume();

        this._nodamageTime = 2.0;
    },

    setupAreaClearDemo : function()
    {
        //this._vx = g_sharedGameScene._mapManager._cameraSpeed;

        this._vx = 0;
        if (this._vy >= 0) this._vy = 0;

        if (gAreaNum+1 < gAreaCnt)
        {
            // warp
            var id = 0;
            if (gWarpPoint.length == 2) id = 1;

            var move = cc.MoveTo.create(1.5, g_sharedGameScene._mapManager.convertMapToScreenPos(gWarpPoint[id]));
            this.runAction(cc.Sequence.create(move, cc.CallFunc.create(
            function(){
                // 到着
                gSubStat = 2;
                gSoundManager.playSE(SE.WARP);
            }, this)));

        }
        else {
            // goal
            var move = cc.MoveTo.create(1.5, g_sharedGameScene._mapManager.convertMapToScreenPos(gGoalPoint));
            this.runAction(cc.Sequence.create(move, cc.CallFunc.create(
            function(){
                // 到着
                gSubStat = 10;
                this.setWin();
                gSoundManager.playSE(SE.GOAL);
            }, this)));
        }


    }

});

//************************************
//  ユニットを登録
//************************************
Spr_Player.getOrCreate = function(no)
{
    var selChild = null;

    selChild = gPlayer;
    if (selChild != null) // && selChild._active == false)
    {
        selChild.born(SpriteData[no], no);
        selChild.setParam(no);
        selChild.schedule(selChild.update);
        return selChild;
    }

    selChild = new Spr_Player(0);
    selChild.born(SpriteData[no], no);
    selChild.setParam(no);
    selChild.schedule(selChild.update);
    
    g_sharedGameScene._ccb_sprLayer.addChild(selChild, selChild._zOrder, selChild.getTag());
    gPlayer = selChild;
    return selChild;
};
