// 半角英数字文字列を全角文字列に変換する
String.prototype.toTwoByteAlphaNumeric = function(){
    return this.replace(/[A-Za-z0-9]/g, function(s) {
        return String.fromCharCode(s.charCodeAt(0) + 0xFEE0);
    });
}


var Base64a = {
encode: function(arr) {
    var i, len, str, buf, tbl;
    if (!arr || !arr.length) {return "";}
    for(i=0,tbl={64:61,63:47,62:43}; i<62; i++) {tbl[i]=i<26?i+65:(i<52?i+71:i-4);} //A-Za-z0-9+/=
    for(i=0,len=arr.length,buf=[],str=""; i<len; i+=3) { //6+2,4+4,2+6
        str += String.fromCharCode(
                                   tbl[arr[i] >>> 2],
                                   tbl[(arr[i]&3)<<4 | arr[i+1]>>>4],
                                   tbl[i+1<len ? (arr[i+1]&15)<<2 | arr[i+2]>>>6 : 64],
                                   tbl[i+2<len ? (arr[i+2]&63) : 64]
                                   );
    }
    return str;
},
decode: function(str) {
    var i, j, len, arr, buf, tbl;
    if (!str || !str.length) {return [];}
    for(i=0,tbl={61:64,47:63,43:62}; i<62; i++) {tbl[i<26?i+65:(i<52?i+71:i-4)]=i;} //A-Za-z0-9+/=
    for(i=0,len=str.length,arr=[],buf=[]; i<len; i+=4) { //6,2+4,4+2,6
        for(j=0; j<4; j++) {buf[j] = tbl[str.charCodeAt(i+j)||0];}
        arr.push(
                 buf[0]<<2|(buf[1]&63)>>>4,
                 (buf[1]&15)<<4|(buf[2]&63)>>>2,
                 (buf[2]&3)<<6|buf[3]&63
                 );
    }
    if (buf[3]===64) {arr.pop();if (buf[2]===64) {arr.pop();}}
    return arr;
}
};



var Utils =
{

delegate: null,

log : function(str)
{
    if (_DEBUG_) cc.log(str);
},
//=============================================================================
// メモリに現在読み込まれている画像のリストをコンソールに表示。
//=============================================================================
//dumpCachedTexture: function ()
//{
//    cc.textureCache.dumpCachedTextureInfo();
//},
cachedTexureInfo: function()
{
	Utils.log("=========>\n "+cc.textureCache.getCachedTextureInfo());
},
//=============================================================================
//	JSON形式か？ check
//=============================================================================
isJson : function(arg)
{
    arg = (typeof(arg) == "function") ? arg() : arg;
    if (typeof(arg) != "string"){
    	return false;
    }

    try{
    	arg = (!JSON) ? eval("(" + arg + ")") : JSON.parse(arg);
    	return true;
    }
    catch(e){
    	return false;
    }
},

//=============================================================================
//	乱数取得 (0 〜 n-1)
//=============================================================================
rand: function(n)
{
	return Math.floor(Math.random() * n);
},
//=============================================================================
//	シーン番号を保存しておく
//=============================================================================
setSceneNum: function(n)
{
	gOldScene = gSceneNum;
	gSceneNum = n;
},
//=============================================================================
//	セーブデータの初期設定
//=============================================================================
dataInit: function()
{
	Utils.dataClear();
    Utils.dataSaveAll();
},
//=============================================================================
//	セーブデータのクリア
//=============================================================================
dataClear: function()
{
	gConfigVersion = CONFIG_VERSION;   		// ゲーム初回起動フラグ
	gVolBgm = DEFAULT_VOLUME;      		// BGM 音量
	gVolSe = DEFAULT_VOLUME;       		// SE 音量

    gDeadPoint.length = 0;
    gDeadPoint = new Array(STAGE_MAX+1);

    gDeadPoint_SP.length = 0;
    gDeadPoint_SP = new Array(STAGE_MAX+1);

    // クリアした回数
    for (var i=0; i<gClearCount.length; i++)
    {
        gClearCount[i] = 0;
        gTryCount[i] = 0;

        gDeadPoint[i] = new Array(2);
        gDeadPoint[i][0] = cc.p(0,0);
        gDeadPoint[i][1] = 0;

        gClearCount_SP[i] = 0;
        gTryCount_SP[i] = 0;

        gDeadPoint_SP[i] = new Array(2);
        gDeadPoint_SP[i][0] = cc.p(0,0);
        gDeadPoint_SP[i][1] = 0;
    }
},
//=============================================================================
//	セーブデータのロード
//=============================================================================
dataLoad: function()
{
	var ls = cc.sys.localStorage;
	var version = parseInt(ls.getItem("configver"));

	if  ( isNaN(version) || version == "" || version == null)
	{
		// 初回起動
		Utils.dataInit();
		return false;
	}
	else
	{
		gStartupFlag = false;
		if (version == CONFIG_VERSION)
		{
            gConfigVersion = version;
			gVolBgm = parseFloat(ls.getItem("bgmvol"));
			gVolSe = parseFloat(ls.getItem("sevol"));

                gDeadPoint.length = 0;
                gDeadPoint = new Array(STAGE_MAX+1);

                gDeadPoint_SP.length = 0;
                gDeadPoint_SP = new Array(STAGE_MAX+1);

                for (var i=0; i<gClearCount.length; i++)
                {
                    gClearCount[i] = parseInt(ls.getItem("clrcnt_"+i));
                    if (isNaN(gClearCount[i]))
                    {
                        gClearCount[i] = 0;
                    }

                    gTryCount[i] = parseInt(ls.getItem("trycnt_"+i));
                    if (isNaN(gTryCount[i]))
                    {
                        gTryCount[i] = 0;
                    }

                    gDeadPoint[i] = new Array(2);
                    gDeadPoint[i][0] = cc.p(parseInt(ls.getItem("deadX_"+i)), parseInt(ls.getItem("deadY_"+i)));
                    gDeadPoint[i][1] = parseInt(ls.getItem("deadArea_"+i))

                    // 裏
                    gClearCount_SP[i] = parseInt(ls.getItem("clrcntSP_"+i));
                    if (isNaN(gClearCount_SP[i]))
                    {
                        gClearCount_SP[i] = 0;
                    }

                    gTryCount_SP[i] = parseInt(ls.getItem("trycntSP_"+i));
                    if (isNaN(gTryCount_SP[i]))
                    {
                        gTryCount_SP[i] = 0;
                    }

                    gDeadPoint_SP[i] = new Array(2);
                    gDeadPoint_SP[i][0] = cc.p(parseInt(ls.getItem("deadXSP_"+i)), parseInt(ls.getItem("deadYSP_"+i)));
                    gDeadPoint_SP[i][1] = parseInt(ls.getItem("deadAreaSP_"+i))
                }
			return true;
		}
		else
		{
			// 初回起動 -2-
			Utils.dataInit();
			return false;
		}
	}
},
//=============================================================================
//	セーブデータのセーブ
//=============================================================================
dataSaveAll: function()
{
 	var ls = cc.sys.localStorage;

    ls.setItem("configver", gConfigVersion);
    this.saveVolume();
    for (var i=0; i<gClearCount.length; i++)
    {
        ls.setItem("clrcnt_"+i, gClearCount[i]);
    }
    for (var i=0; i<gTryCount.length; i++)
    {
        ls.setItem("trycnt_"+i, gTryCount[i]);
    }
    for (var i=0; i<gDeadPoint.length; i++)
    {
        ls.setItem("deadX_"+i, gDeadPoint[i][0].x);
        ls.setItem("deadY_"+i, gDeadPoint[i][0].y);
        ls.setItem("deadArea_"+i, gDeadPoint[i][1]);
    }
    // 裏
    for (var i=0; i<gClearCount_SP.length; i++)
    {
        ls.setItem("clrcntSP_"+i, gClearCount_SP[i]);
    }
    for (var i=0; i<gTryCount_SP.length; i++)
    {
        ls.setItem("trycntSP_"+i, gTryCount_SP[i]);
    }
    for (var i=0; i<gDeadPoint_SP.length; i++)
    {
        ls.setItem("deadXSP_"+i, gDeadPoint_SP[i][0].x);
        ls.setItem("deadYSP_"+i, gDeadPoint_SP[i][0].y);
        ls.setItem("deadAreaSP_"+i, gDeadPoint_SP[i][1]);
    }
},
saveData : function(key, value)
{
    cc.sys.localStorage.setItem(key, ""+value);
},
saveVolume: function()
{
    var ls = cc.sys.localStorage;
    ls.setItem("bgmvol",""+gVolBgm);
    ls.setItem("sevol",""+gVolSe);
},

saveClearCount: function(i)
{
    var ls = cc.sys.localStorage;
    if (!gSpecialStage){
        ls.setItem("clrcnt_"+i, gClearCount[i]);
    }
    else {
        ls.setItem("clrcntSP_"+i, gClearCount_SP[i]);
    }
},
saveTryCount: function(i)
{
    var ls = cc.sys.localStorage;
    if (!gSpecialStage) {
        ls.setItem("trycnt_"+i, gTryCount[i]);
    }
    else {
        ls.setItem("trycntSP_"+i, gTryCount_SP[i]);
    }
},
saveDeadPoint: function(i)
{
    var ls = cc.sys.localStorage;
    if (!gSpecialStage) {
        ls.setItem("deadX_"+i, gDeadPoint[i][0].x);
        ls.setItem("deadY_"+i, gDeadPoint[i][0].y);
        ls.setItem("deadArea_"+i, gDeadPoint[i][1]);
    }
    else {
        ls.setItem("deadXSP_"+i, gDeadPoint_SP[i][0].x);
        ls.setItem("deadYSP_"+i, gDeadPoint_SP[i][0].y);
        ls.setItem("deadAreaSP_"+i, gDeadPoint_SP[i][1]);
    }
},

getAngleToTarget : function(x, y, tx, ty)
{
    var ang = Math.atan2(ty - y, tx - x) / (Math.PI / 180);
    //if (ang < 0) ang += 360;
    ang = 270 - ang; //Math.floor(ang % 360);
    //if (ang < 0) ang += 360;
    if (ang >= 360) ang -= 360;
    return Math.floor(ang);
},

//=============================================================================
//	ネイティブからポーズ掛ける。
//=============================================================================
onPauseFromNative: function()
{
    // ＠今回は未使用
	//if (gSceneNum == SCENE.MAIN && g_sharedGameScene != null)
	//{
	//	g_sharedGameScene.onPauseClicked();
	//}
},
didEnterBackground : function()
{
	if (gSceneNum == SCENE.MAIN && g_sharedGameScene != null)
	{
		g_sharedGameScene.didEnterBackground();
	}
},
willEnterForeground : function()
{
	if (gSceneNum == SCENE.MAIN && g_sharedGameScene != null)
	{
		g_sharedGameScene.willEnterForeground();
	}
},

//=============================================================================
//
//=============================================================================
showBannerView : function()
{
    if (gBannerFlag) return;
    gBannerFlag = true;

    if (isAndroid != 1)
    {
        // iOS
        jsb.reflection.callStaticMethod("RootViewController", "showBanner");
    }
    else
    {
        // android
    //  jsb.reflection.callStaticMethod(packageName,"showBannerView", "(I)V", 1);
    }
},
hideBannerView : function()
{
    if (!gBannerFlag) return;
    gBannerFlag = false;

    if (isAndroid != 1)
    {
        // iOS
     jsb.reflection.callStaticMethod("RootViewController", "hideBanner");
    }
    else
    {
        // android
    //  jsb.reflection.callStaticMethod(packageName,"hideBannerView", "(I)V", 1);
    }
},
showRectangleView : function()
{
    if (isAndroid != 1)
    {
        // iOS
    jsb.reflection.callStaticMethod("RootViewController", "showInterCept");
    }
    else
    {
        // android
     //   jsb.reflection.callStaticMethod(packageName,"showRectangleView", "(I)V", 1);
    }
},
hideRectangleView : function()
{
    if (isAndroid != 1)
    {
        // iOS
    //    jsb.reflection.callStaticMethod("NativeOcClass", "hideRectangleView");
    }
    else
    {
        // android
    //    jsb.reflection.callStaticMethod(packageName,"hideRectangleView", "(I)V", 1);
    }
},

showInterstitialVideo : function(delegate)
{
    this.delegate = delegate;

    if (isAndroid != 1)
    {
        // iOS
    //    jsb.reflection.callStaticMethod("NativeOcClass", "showInterstitialVideo");
    }
    else
    {
        // android
     //   jsb.reflection.callStaticMethod(packageName,"showInterstitialVideo", "(I)V", 1);
    }
},
showV4VCVideo : function(delegate)
{
    this.delegate = delegate;

  //  gSoundManager.pause();

    if (isAndroid != 1)
    {
        // iOS
    //    jsb.reflection.callStaticMethod("NativeOcClass", "showV4VCVideo");
    }
    else
    {
        // android
    //    jsb.reflection.callStaticMethod(packageName,"showV4VCVideo", "(I)V", 1);
    }
},
onAdColonyV4VCReward : function(flg)
{
    //if (data)
    //{
  //  this.delegate.getRewardVideo(flg);
    //}
},

isV4VCRewardAvailable : function()
{
    if (isAndroid != 1)
    {
        // iOS
    //    return jsb.reflection.callStaticMethod("NativeOcClass", "isV4VCRewardAvailable");
    }
    else
    {
        // android
     //   return //jsb.reflection.callStaticMethod(packageName,"isV4VCRewardAvailable", "(I)Z", 1);
    }
},

isShowMaio : function()
{
    if (isAndroid != 1)
    {
        // iOS
 //       return jsb.reflection.callStaticMethod("NativeOcClass", "isShowMaio");
    }
    else
    {
        // android
//        return jsb.reflection.callStaticMethod(packageName,"isShowMaio", "(I)Z", 1);
    }
},
showMaio : function(delegate)
{
 //   this.delegate = delegate;

    //gSoundManager.stopBgm();
//    gSoundManager.pause();

    if (isAndroid != 1)
    {
        // iOS
 //       jsb.reflection.callStaticMethod("NativeOcClass", "showMaio");
    }
    else
    {
        // android
 //       jsb.reflection.callStaticMethod(packageName,"showMaio", "(I)V", 1);
    }
},

isShowUnityAds : function()
{
    if (isAndroid != 1)
    {
        // iOS
 //       return jsb.reflection.callStaticMethod("NativeOcClass", "isShowUnityAds");
    }
    else
    {
        // android
  //      return jsb.reflection.callStaticMethod(packageName,"isShowUnityAds", "(I)Z", 1);
    }
},
showUnityAds : function(delegate)
{
    this.delegate = delegate;

    //gSoundManager.stopBgm();
//    gSoundManager.pause();

    if (isAndroid != 1)
    {
        // iOS
 //       jsb.reflection.callStaticMethod("NativeOcClass", "showUnityAds");
    }
    else
    {
        // android
 //       jsb.reflection.callStaticMethod(packageName,"showUnityAds", "(I)V", 1);
    }
},

postToTwitter: function(delegate)
{
    this.delegate = delegate;

    var tweet = "";
        tweet = TWEET_MESSAGE[gStageNum];

    tweet += "\niPhone:\nhttps://appsto.re/jp/KmXQib.i\n ";

    tweet += "\nAndroid:\nhttps://goo.gl/cWIDT6";

    if (isAndroid != 1)
    {
        // iOS
        jsb.reflection.callStaticMethod("RootViewController", "postToTwitter:", tweet);
    }
    else
    {
        // android
    //    jsb.reflection.callStaticMethod(packageName,"postToTwitter", "(Ljava/lang/String;Ljava/lang/String;)V", tweet, "");
    }
},
    
//--------
startLive: function()
    {
        if (gRecordingNow) return;
        
        gRecordingNow = true;
        
        Utils.log("ライブ開始")
        
        if (isAndroid != 1)
        {
            // iOS
            jsb.reflection.callStaticMethod("RootViewController", "liveStart");
        }
        else
        {
            // android
        }
    },
startRec: function()
    {
        if (gRecordingNow) return;
        
        gRecordingNow = true;
        
        Utils.log("録画開始")
        
        if (isAndroid != 1)
        {
            // iOS
            jsb.reflection.callStaticMethod("RootViewController", "recStart");
        }
        else
        {
            // android
        }
    },
    // 録画停止
stopRec : function()
    {
        if (!gRecordingNow) return;
        
        gRecordingNow = false;
        
        Utils.log("録画終了")
        
        if (isAndroid != 1)
        {
            // iOS
            jsb.reflection.callStaticMethod("RootViewController", "recStop");
        }
        else
        {
            // android
            //     jsb.reflection.callStaticMethod(packageName,"stopRecording", "(I)V", 1);
        }
        
    },
    
    
// Twitter投稿のリワード受け取る
onTwitterReward : function(flg)
{
    //if (data)
    //{
  //  this.delegate.getRewardTwitter(flg);
    //}
},

webjump : function(url)
{
//    if (type == "help")
//    {
//        url = URL_HELP;
//    }
//    else return;

    if (isAndroid != 1)
    {
        // iOS
        jsb.reflection.callStaticMethod("RootViewController", "openBrowser:", url);
    }
    else
    {
        // android
     //   jsb.reflection.callStaticMethod(packageName,"openBrowser", "(Ljava/lang/String;)V", url);
    }
    this._pressedButton = false;
},
// ネットワーク接続チェック
checkNetworkConnect : function()
{
    var ret
    if (isAndroid != 1)
    {
        // iOS
 //       ret = jsb.reflection.callStaticMethod("RootViewController", "networkConnectCheck");
    }
    else
    {
        // android
  //      ret = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","networkConnectCheck", "(Ljava/lang/String;)Z", "dummy");
    }
    return ret;
},

showIndicator: function()
{
},
hideIndicator: function()
{
},
//----
loadImage: function(imgUrl, cb)
    {
        var xhr = cc.loader.getXMLHttpRequest();     //new XMLHttpRequest();
        xhr.open('GET', imgUrl);
        xhr.responseType = "arraybuffer";
        
        xhr.onreadystatechange = function ()
        {
            if ( xhr.readyState == 4 && ( xhr.status >= 200 && xhr.status <= 207 ) )
            {
            //通信結果データ取得
            var data = new Uint8Array( xhr.response);
            var binaryData = "";
            for (var i = 0, len = data.byteLength; i < len; i++) {
                //バイナリデータへ変換
                binaryData += String.fromCharCode(data[i]);
            }
            //Imageオブジェクト生成

      //     var base64str = "data:image/png;base64," + Base64a.decode(binaryData); //画像読み込み
            var base64str = "data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACwAAAAAAQABAAACAkQBADs=";
            cc.loader.loadImg(base64str , {isCrossOrigin : false}, function(err, img) {
                                 cb( img );
//                                  var whiteBox = cc.Sprite.createWithTexture(img);
//                                  layer.addChild(whiteBox,1);
                });
                
                
//            image.onload = function() { //取得要求時に受け取ったコールバック関数でImageを返却
//            cb( image ); };
            }
        };
        xhr.send(); 
},

//-----------------------------------------------------------------------------
};
